// 2 sensors with stepmotors
// sensors detect light, if they are in the black line, the output will be HIGH, otherwise, will be LOW
#include <Servo.h>     
#include <Stepper.h>

int button = 2;
int sensorL = 6;
int sensorR = 3;          //assign pins
bool buttonPressed = false;

int motorR = 7;
int dirR = 8;             // direction: if HIGH go forwards, if LOW go backwards

int motorL = 5;
int dirL = 12;

int red = 9;

int servoPin = 10;
const int green = 11;
Servo servo;
Stepper stepperL(200, motorL, dirL);
Stepper stepperR(200, motorR, dirR);
int stepDelay = 25;
int Tiles = 0;
int counter = 0;
const int stepsPerRevolution = 200; //to control the speed
//The speed of a motor is determined by the frequency of the pulses we send to the STEP pin.
// The higher the pulses, the faster the motor runs.


void setup() {
  Serial.begin(9600);
  pinMode(button, INPUT_PULLUP);      //pullup resistor to eliminate floating voltage values
  pinMode(sensorL, INPUT);            //assign I/O
  pinMode(sensorR, INPUT);
  pinMode(motorL, OUTPUT);
  pinMode(motorR, OUTPUT);
  pinMode(dirL, OUTPUT);
  pinMode(dirR, OUTPUT);
  pinMode(red, OUTPUT);
  pinMode(green, OUTPUT);
  servo.attach(servoPin);

}

void loop() {
  if (digitalRead(button) == LOW) {               //wait until the button is pressed to start the program
    buttonPressed = true;
    //Serial.println("hello");
  }

  if (buttonPressed) {
    if (digitalRead(sensorL) == HIGH && digitalRead(sensorR) == LOW) {    //if right sensor is not on line, turn left (low is black line found)
      stepperR.step(4);
      //stepperL.step(-1);
      digitalWrite(green, HIGH);
      digitalWrite(red, LOW);
      delay(stepDelay);
      Serial.println(digitalRead(sensorL));
      Serial.println(digitalRead(sensorR));
    }
    else if ((digitalRead(sensorL) == LOW && digitalRead(sensorR) == HIGH)) {          //if left is not on line, turn right
      stepperL.step(4);
      //stepperR.step(-1);
      digitalWrite(green, HIGH);
      digitalWrite(red, LOW);
      delay(stepDelay);
      Serial.println(digitalRead(sensorL));
      Serial.println(digitalRead(sensorR));
    }
    else if (digitalRead(sensorL) == HIGH && digitalRead(sensorR) == HIGH) {            //if both are on line, drive forward
      stepperR.step(4);
      stepperL.step(4);
      digitalWrite(green, HIGH);
      digitalWrite(red, LOW);
      counter++;
      if (counter == 30) {
        counter = 0;

        servo.write(0);
        delay(800);  
        servo.write(180);                     //continuous rotation to move forward
        delay(800);                           // waits 800ms for the hammer to be completely moved foward (TEST HOW MUCH TIME IS NEEDED FOR THIS!)

        servo.write(0);                       //continuous rotation to move backwards
        delay(800);                           // waits 800ms for the hammer to be completely moved backwards (TEST HOW MUCH TIME IS NEEDED FOR THIS!)

        Tiles++;
      }
      delay(stepDelay);
    }
    else if (digitalRead(sensorL) == LOW && digitalRead(sensorR) == LOW) {         //if both are not on line
      digitalWrite(red, HIGH);
      digitalWrite(green, LOW);
      buttonPressed = false;
    }
    if (Tiles == 20) {
      buttonPressed = false;
      digitalWrite(red, LOW);
      digitalWrite(green, HIGH);
      delay(1000);
      digitalWrite(green, LOW);
      delay(1000);
    }

  }
}
